///////////////////////////////////////////////////////////////
// ļ: vcthread.cpp
// : д̹߳ʵļ
// : 
// : 1999.05.15 - ޸ģ
// E_mai:wnf@wisepeak.com
// Http://www.wisepeak.com
///////////////////////////////////////////////////////////////
// 汾: 1.0
///////////////////////////////////////////////////////////////
// ע:漰ͨѶ,ҪϵͳͬʱӦ¼û,
//    Ըôʹö߳ʵ
///////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "vcThread.h"
#include "define.h"

IMPLEMENT_DYNAMIC(TReadThread, CWinThread)

////////////////////////////////////////////////////////
//  : TReadThread.Thread
//
//  Ŀ: ߳вִӦĹ.
//
//  :
//    None.
//
//  ֵ:
//    None.
//
//  ע:
//
//    The Read Thread uses overlapped ReadFile and sends any data
//    read from the comm port to the Comm32Window.  This is
//    eventually done through a PostMessage so that the Read Thread
//    is never away from the comm port very long.  This also provides
//    natural desynchronization between the Read thread and the UI.
//
//    If the CloseEvent object is signaled, the Read Thread returns.
//
//        Separating the Read and Write threads is natural for a application
//    where there is no need for synchronization between
//    reading and writing.  However, if there is such a need (for example,
//    most file transfer algorithms synchronize the reading and writing),
//     it would make a lot more sense to have a single thread to handle
//    both reading and writing.
//

TReadThread::TReadThread()
{

}

BOOL TReadThread::InitInstance()
{
   char szInputBuffer[TINPUTBUFFERSIZE];
   DWORD nNumberOfBytesRead;
   HANDLE HandlesToWaitFor[3];
   DWORD dwHandleSignaled;
   DWORD fdwEvtMask;
   // Needed for overlapped I/O (ReadFile)
   OVERLAPPED overlappedRead;
   // Needed for overlapped Comm Event handling.
   OVERLAPPED overlappedCommEvent;
   memset( &overlappedRead,0, sizeof(overlappedRead));
   memset( &overlappedCommEvent,0, sizeof(overlappedCommEvent));
   // Lets put an event in the Read overlapped structure.
   overlappedRead.hEvent = CreateEvent( NULL, true, false, NULL);
   if (overlappedRead.hEvent == 0 )
   {
      PostHangupCall();
      goto EndReadThread;
   }
   ResetEvent(overlappedRead.hEvent);
   // And an event for the CommEvent overlapped structure.
   overlappedCommEvent.hEvent = CreateEvent( NULL, true, false, NULL);
   if (overlappedCommEvent.hEvent == 0 )
   {
      PostHangupCall();
      goto EndReadThread;
   }
   ResetEvent(overlappedCommEvent.hEvent);
   // We will be waiting on these objects.
   HandlesToWaitFor[0] = m_hCloseEvent;
   HandlesToWaitFor[1] = overlappedCommEvent.hEvent;
   HandlesToWaitFor[2] = overlappedRead.hEvent;
   // Setup CommEvent handling.
   // Set the comm mask so we receive error signals.
   if (! SetCommMask(m_hCommFile, EV_ERR | EV_RLSD))// | EV_RING )) 
   {
      PostHangupCall();
      goto EndReadThread;
   }

   // Start waiting for CommEvents (Errors)
   if (! SetupCommEvent( &overlappedCommEvent,  fdwEvtMask ) )
      goto EndReadThread;

   // Start waiting for Read events.
   if (! SetupReadEvent( &overlappedRead,
      szInputBuffer, TINPUTBUFFERSIZE,
      nNumberOfBytesRead ) )
      goto EndReadThread;
   // Keep looping until we break out.
   while (true)
   {
      // Wait until some event occurs (data to read; error; stopping).
      dwHandleSignaled = WaitForMultipleObjects(3, HandlesToWaitFor,false, INFINITE);
      // Which event occured?
      switch (dwHandleSignaled) 
      {
      case  WAIT_OBJECT_0:     // Signal to end the thread.
         // Time to return.
         goto EndReadThread;         
      case WAIT_OBJECT_0 + 1: // CommEvent signaled.
         // Handle the CommEvent.
         if (! HandleCommEvent( &overlappedCommEvent, fdwEvtMask, true ) )
            goto EndReadThread;
         // Start waiting for the next CommEvent.
         if (! SetupCommEvent( &overlappedCommEvent, fdwEvtMask ) )
            goto EndReadThread;
         break;
      case WAIT_OBJECT_0 + 2: // Read Event signaled.
         // Get the new data!
         if (! HandleReadEvent( &overlappedRead,szInputBuffer,
            TINPUTBUFFERSIZE,nNumberOfBytesRead )) 
            goto EndReadThread;
         // Wait for more new data.
         if (! SetupReadEvent( &overlappedRead,szInputBuffer, TINPUTBUFFERSIZE,
            nNumberOfBytesRead ) )
            goto EndReadThread;
         break;
      case WAIT_FAILED:       // Wait failed.  Shouldn't happen.
         PostHangupCall();
         goto EndReadThread;         
      default:    // This case should never occur.
         PostHangupCall();
         goto EndReadThread;
      } //{case dwHandleSignaled}
   } //{while True}
   // Time to clean up Read Thread.
EndReadThread:
   PurgeComm( m_hCommFile, PURGE_RXABORT + PURGE_RXCLEAR );
   CloseHandle( overlappedRead.hEvent );
   CloseHandle( overlappedCommEvent.hEvent );
   return false;
}


///////////////////////////////////////////////////////
//߳ṩķ
//
//  : SetupCommEvent(LPOVERLAPPED, LPDWORD)
//
//  Ŀ: Sets up the overlapped WaitCommEvent call.
//
//  :
//    lpOverlappedCommEvent - Pointer to the overlapped structure to use.
//    lpfdwEvtMask          - Pointer to DWORD to received Event data.
//
//  ֵ:
//    TRUE if able to successfully setup the WaitCommEvent.
//    FALSE if unable to setup WaitCommEvent, unable to handle
//    an existing outstanding event or if the CloseEvent has been signaled.
//
//  ע:
//
//    This function is a helper function for the Read Thread that sets up
//    the WaitCommEvent so we can deal with comm events (like Comm errors)
//    if they occur.
//

bool TReadThread::SetupCommEvent( OVERLAPPED* lpOverlappedCommEvent,DWORD & lpfdwEvtMask)
{
   DWORD dwLastError;
   //Result = false;

StartSetupCommEvent:   
   //ȷر¼ûб鿴ĿΪ˷ֹر¼ݹ.
   //ֵΪWAIT_TIMEOUTʱر¼ѱ
   if (WAIT_TIMEOUT != WaitForSingleObject( m_hCloseEvent,0 ) )
      return false;
   // Start waiting for Comm Errors.
   if (WaitCommEvent( m_hCommFile, &lpfdwEvtMask, lpOverlappedCommEvent ) )
   {
      // This could happen if there was an error waiting on the
      // comm port.  Lets try and handle it.
      if (! HandleCommEvent( NULL, lpfdwEvtMask, false ) )
      {
         //{??? GetOverlappedResult does not handle "NULL" as defined by Borland}
         return false;
      }
      // What could cause infinite recursion at this point?
      goto StartSetupCommEvent;
   }

   // We expect ERROR_IO_PENDING returned from WaitCommEvent
   // because we are waiting with an overlapped structure.
   dwLastError = GetLastError();
   // LastError was ERROR_IO_PENDING, as expected.
   if (dwLastError == ERROR_IO_PENDING)    
      return true;
   
   // Its possible for this error to occur if the
   // service provider has closed the port.  Time to end.
   if (dwLastError == ERROR_INVALID_HANDLE )
      return false;
   // Unexpected error. No idea what could cause this to happen.
   PostHangupCall();
   return false;
}//{TReadThread.SetupCommEvent}


//////////////////////////////////////////////////////////
//  : SetupReadEvent(LPOVERLAPPED, LPSTR, DWORD, LPDWORD)
//
//  Ŀ: Sets up an overlapped ReadFile
//
//  :
//    lpOverlappedRead      - address of overlapped structure to use.
//    lpszInputBuffer       - Buffer to place incoming bytes.
//    dwSizeofBuffer        - size of lpszInputBuffer.
//    lpnNumberOfBytesRead  - address of DWORD to place the number of read bytes.
//
//  ֵ:
//    TRUE if able to successfully setup the ReadFile.  FALSE if there
//    was a failure setting up or if the CloseEvent object was signaled.
//
//  ע:
//
//    This function is a helper function for the Read Thread.  This
//    function sets up the overlapped ReadFile so that it can later
//    be waited on (or more appropriatly, so the event in the overlapped
//    structure can be waited upon).  If there is data waiting, it is
//    handled and the next ReadFile is initiated.
//    Another possible reason for returning FALSE is if the comm port
//    is closed by the service provider.
//
//

bool TReadThread::SetupReadEvent( OVERLAPPED* lpOverlappedRead,LPSTR lpszInputBuffer,DWORD dwSizeofBuffer,DWORD & lpnNumberOfBytesRead)
{
   DWORD dwLastError;
   //Result = False;
StartSetupReadEvent:
   // Make sure the CloseEvent hasn't been signaled yet.
   // Check is needed because this function is potentially recursive.
   if (WAIT_TIMEOUT != WaitForSingleObject(m_hCloseEvent,0) )
      return false;
   // Start the overlapped ReadFile.
   if (ReadFile( m_hCommFile,
      lpszInputBuffer, dwSizeofBuffer,
      &lpnNumberOfBytesRead, lpOverlappedRead ) )
   {
      // This would only happen if there was data waiting to be read.
      // Handle the data.
      if (! HandleReadData( lpszInputBuffer, lpnNumberOfBytesRead ) )
         return false;
      // Start waiting for more data.
      goto StartSetupReadEvent;
   }
   // ReadFile failed.  Expected because of overlapped I/O.
   dwLastError = GetLastError();
   // LastError was ERROR_IO_PENDING, as expected.
   
   if (dwLastError == ERROR_IO_PENDING )   
      return true;
   
   // Its possible for this error to occur if the
   // service provider has closed the port.  Time to end.
   if (dwLastError == ERROR_INVALID_HANDLE )
      return false;
   // Unexpected error come here. No idea what could cause this to happen.
   PostHangupCall();
   return false;
}//{TReadThread.SetupReadEvent}


///////////////////////////////////////////////////////
//  : HandleCommEvent(LPOVERLAPPED, LPDWORD, BOOL)
//
//  Ŀ: ׼ͨѶ¼.
//
//  :
//    lpOverlappedCommEvent - Pointer to the overlapped structure to use.
//    lpfdwEvtMask          - Pointer to DWORD to received Event data.
//    fRetrieveEvent        - Flag to signal if the event needs to be
//                            retrieved, or has already been retrieved.
//
//  ֵ:
//    TRUE if able to handle a Comm Event.
//    FALSE if unable to setup WaitCommEvent, unable to handle
//    an existing outstanding event or if the CloseEvent has been signaled.
//
//  ע:
//
//    This function is a helper function for the Read Thread that (if
//    fRetrieveEvent == TRUE) retrieves an outstanding CommEvent and
//    deals with it.  The only event that should occur is an EV_ERR event,
//    signalling that there has been an error on the comm port.
//
//    Normally, comm errors would not be put into the normal data stream
//    as this sample is demonstrating.  Putting it in a status bar would
//    be more appropriate for a real application.
//

bool TReadThread::HandleCommEvent(OVERLAPPED* lpOverlappedCommEvent,DWORD & lpfdwEvtMask,bool fRetrieveEvent)
{
   DWORD dwDummy;
   DWORD dwErrors;
   DWORD dwLastError;
   // If this fails, it could be because the file was closed (and I/O is
   // finished) or because the overlapped I/O is still in progress.  In
   // either case (or any others) its a bug and return FALSE.
   if (fRetrieveEvent) 
   {
      if (! GetOverlappedResult( m_hCommFile,lpOverlappedCommEvent, &dwDummy, false))
      {
         dwLastError = GetLastError();
         // Its possible for this error to occur if the
         // service provider has closed the port.  Time to end.
         if (dwLastError == ERROR_INVALID_HANDLE )
            return false;
         PostHangupCall();//ERROR_IO_INCOMPLETE
         return false;
      }
   }
   // Was the event an error? EV_ERR 0x80
   if ((lpfdwEvtMask && EV_ERR) != 0 )
   {
      // Which error was it?
      if (! ClearCommError( m_hCommFile, &dwErrors, NULL ) )
      {
         dwLastError = GetLastError();
         // Its possible for this error to occur if the
         // service provider has closed the port.  Time to end.
         if (dwLastError == ERROR_INVALID_HANDLE )
            return false;
         PostHangupCall ();
         return false;
      }
      // Its possible that multiple errors occured and were handled
      // in the last ClearCommError.  Because all errors were signaled
      // individually, but cleared all at once, pending comm events
      // can yield EV_ERR while dwErrors equals 0.  Ignore this event.
      if (! ReceiveError( dwErrors )) return false;
      return true;
   }
   else
   {
      PostHangupCall();
      return false;
   }
}// {TReadThread.HandleCommEvent}

bool TReadThread::HandleReadEvent( OVERLAPPED* lpOverlappedRead,LPSTR lpszInputBuffer,DWORD dwSizeofBuffer,DWORD & lpnNumberOfBytesRead)
{
   DWORD dwLastError;
   //Result = false;
   if (GetOverlappedResult( m_hCommFile,lpOverlappedRead, &lpnNumberOfBytesRead, false ) )
   {
       return( HandleReadData( lpszInputBuffer, lpnNumberOfBytesRead ));
   }
   // Error in GetOverlappedResult; handle it.
   dwLastError = GetLastError();
   // Its possible for this error to occur if the
   // service provider has closed the port.  Time to end.
   if (dwLastError == ERROR_INVALID_HANDLE )
      return false;
   // Unexpected error come here. No idea what could cause this to happen.
   PostHangupCall();
   return false;
}// {TReadThread.HandleReadEvent}


//////////////////////////////////////////////////////////
//  : HandleReadData(LPCSTR, DWORD)
//
//  Ŀ: Deals with data after its been read from the comm file.
//
//  :
//    lpszInputBuffer  - Buffer to place incoming bytes.
//    dwSizeofBuffer   - size of lpszInputBuffer.
//
//  ֵ:
//    TRUE if able to successfully handle the data.
//    FALSE if unable to allocate memory or handle the data.
//
//  ע:
//
//    This function is yet another helper function for the Read Thread.
//    It LocalAlloc()s a buffer, copies the new data to this buffer and
//    calls PostWriteToDisplayCtl to let the EditCtls module deal with
//    the data.  Its assumed that PostWriteToDisplayCtl posts the message
//    rather than dealing with it right away so that the Read Thread
//    is free to get right back to waiting for data.  Its also assumed
//    that the EditCtls module is responsible for LocalFree()ing the
//    pointer that is passed on.
//

bool TReadThread::HandleReadData(LPCSTR lpszInputBuffer, DWORD dwSizeofBuffer)
{
   LPSTR lpszPostedBytes;
//Result = false;
// If we got data and didn't just time out empty...
   if (dwSizeofBuffer != 0 )
   {
      // Do something with the bytes read.
      lpszPostedBytes = (LPSTR)( LocalAlloc( LPTR, dwSizeofBuffer+1 ) );
      if (lpszPostedBytes == NULL )
      {
         // Out of memory        
         PostHangupCall();
         return false;
       }
       strncpy( lpszPostedBytes,lpszInputBuffer,dwSizeofBuffer);
       lpszPostedBytes[dwSizeofBuffer] = '\0';
       return (ReceiveData( lpszPostedBytes, dwSizeofBuffer ));
   }
   return false;
}//{TReadThread.HandleReadData}

bool TReadThread::ReceiveData(LPSTR lpNewString,DWORD dwSizeofNewString)
{
   if (! PostMessage(m_handlemsg,USER_RECEIVEDATA,WPARAM(dwSizeofNewString), LPARAM(lpNewString)))
   {
      PostHangupCall();
      return false;
   }
   return true;
}
   


bool TReadThread::ReceiveError(DWORD EvtMask)
{
   if (! PostMessage(m_handlemsg,USER_RECEIVEDATAERROR, 0, LPARAM(EvtMask) ) )
   {   
      PostHangupCall ();
      return false;
   }
   return true; 
}

void TReadThread::PostHangupCall()
//̹߳ʱ߳¼û
{            //մ        ʱ¼ʶ
   int i=1;
   PostMessage(m_handlemsg,USER_ONCOMMHANGUP, 0, LPARAM(i));
}


IMPLEMENT_DYNAMIC(TWriteThread, CWinThread)
////////////////////////////////////////////////////////
//  :  TWriteThread::TWriteThread
//
//  Ŀ: д̵߳ʼ
//
//  : 
//
//  ֵ: 
//
//  ע:
//
//    д߳ʹϢѭȴҪдַ,õд뵽С
//    յرϢر˳
//    ʹϢķʹ򴮿дûĲǲͬġ
/////////////////////////////////////////////////////////////////////////////
TWriteThread::TWriteThread()
{

}

//////////////////////////////////////////////////////////////////
//̴߳ʵ壬FALSEʱʾ߳̽
//////////////////////////////////////////////////////////////////
BOOL TWriteThread::InitInstance()
{
   MSG msg;
   DWORD dwHandleSignaled;
   OVERLAPPED overlappedWrite;
   BOOL CompleteOneWriteRequire;
   BOOL contiflag;
   // overlapped ʽҪ洦Ľṹ.
   memset( &overlappedWrite,0, sizeof(overlappedWrite));
   overlappedWrite.hEvent = CreateEvent( NULL, true, false, NULL );
   //ûдʺϵ¼
   if (overlappedWrite.hEvent == 0 )
   {
      PostHangupCall();
      goto EndWriteThread;
   }
   CompleteOneWriteRequire = false;
   //ѭֱ.
   while (true)
   {      
      contiflag=false;
      if (! PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
      {
         // ûϢȴϢֹ߲ͣ
         m_pbSendDataEmpty = true;//ʱȻûҪ
         if (CompleteOneWriteRequire) //һδ
         {
            if (!PostMessage(m_handlemsg,USER_DATASENDFINISHED, 0, 0 ) )
            {
               PostHangupCall();
               goto EndWriteThread;
            }
         }
         CompleteOneWriteRequire = false;
         dwHandleSignaled = MsgWaitForMultipleObjects(1, &m_hCloseEvent, false,
                                                       INFINITE, QS_ALLINPUT);
         switch (dwHandleSignaled)
         {
         case WAIT_OBJECT_0:     // رϢ!
               // ˳.
               goto EndWriteThread;
               break; 
         case WAIT_OBJECT_0 + 1: // õµϢ.
               // ѭ.
               contiflag =true;
               break;
         case WAIT_FAILED:       // ʱܳ.
               PostHangupCall();
               goto EndWriteThread;
               break;
         default:                // ܳ.
               PostHangupCall();
               goto EndWriteThread;
         }
      }
      if (contiflag) continue;
      // ȷڽʱǷйرϢ
      if (WAIT_TIMEOUT != WaitForSingleObject(m_hCloseEvent,0) )
         goto EndWriteThread;
      // ϢʱжԻ.
      //ؼò
      if (msg.hwnd != NULL )
      {
         TranslateMessage(&msg);
         DispatchMessage(&msg);
         continue;
      }

      // õϢ.
      switch ( msg.message )
      {
      case USER_WRITEPORT:  // 򴮿дַ.
         // 򴮿дַ.  HandleWriteData
         // ֱдݺŷ,
         // ǳִ߶˿ڱر.
         if (! HandleWriteData( &overlappedWrite,
                                 (char*)(msg.lParam), DWORD(msg.wParam) ) )
         {
            // õϢṹͷ
            LocalFree( HLOCAL(msg.lParam) );
            goto EndWriteThread;
         }
         CompleteOneWriteRequire = true;//ɹһд
         // д뵽Ϣṹеݿռ.
         LocalFree( HLOCAL(msg.lParam) );
      }
   } //{main loop}
   //д߳.
EndWriteThread:
   PurgeComm(m_hCommFile, PURGE_TXABORT + PURGE_TXCLEAR);
   m_pbSendDataEmpty = true;
   CloseHandle(overlappedWrite.hEvent);
   return false;
}//{TWriteThread.Execute}


////////////////////////////////////////////////////////
//  : HandleWriteData(LPOVERLAPPED, LPCSTR, DWORD)
//
//  Ŀ: 򴮿ļдַ.
//
//  :
//    lpOverlappedWrite      - WriteFileʹõLPOVERLAPPEDṹ
//    pDataToWrite           - Ҫдַ.
//    dwNumberOfBytesToWrite - ַĳ.
//
//  ֵ:
//    ֽڶдʱֵ㣩. 򷵻ؼֵ㣩
//
//  ע:
//
//    úд̵߳ĸʵ򴮿д.
//    עõýֱд߳̽дյ̵߳Ϣ.
//    ؼֵʱܵԭǴڱṩ߹ر
//
bool TWriteThread::HandleWriteData(OVERLAPPED* lpOverlappedWrite,LPSTR pDataToWrite, DWORD dwNumberOfBytesToWrite)
{
   DWORD dwLastError;
   DWORD dwNumberOfBytesWritten,dwWhereToStartWriting,dwHandleSignaled;
   HANDLE HandlesToWaitFor[2];
   //Result = false;//ȱʡֵ
   dwNumberOfBytesWritten = 0;//ѾдַΪ
   dwWhereToStartWriting = 0; // ַĿʼλдַ.
   //¼¼
   HandlesToWaitFor[0] = m_hCloseEvent;//ر¼
   HandlesToWaitFor[1] = lpOverlappedWrite->hEvent;
   // ѭֱַд.
   do
   {
   // ʼ/.
      if (! WriteFile( m_hCommFile,//ļ
                       &(pDataToWrite[ dwWhereToStartWriting ]),//ÿνŴʣµַ
                       dwNumberOfBytesToWrite, &dwNumberOfBytesWritten,
                       lpOverlappedWrite ) )
      {
         //дʧܣҪõ.
         dwLastError = GetLastError();
         // ṩ߹ر˴ڻ߳ʱ򽫳Ĵ
         if (dwLastError == ERROR_INVALID_HANDLE)   return false;
         //֪Ĵ.
         if (dwLastError != ERROR_IO_PENDING )
         {
            PostHangupCall();//ûӦ¼
            return false;
         };
         // ǿԴ.ʱûеȴдݱ㷵FALSE
         // ȴд̽յֹͣźš
         dwHandleSignaled = WaitForMultipleObjects(2, HandlesToWaitFor,
                             false, INFINITE);

         switch ( dwHandleSignaled )
         {
         case  WAIT_OBJECT_0:     // յ˹رϢ!
               // ˳.
               return false;

         case WAIT_OBJECT_0 + 1: // д.            
            // õдĽ
            if (! GetOverlappedResult(m_hCommFile,
                                     lpOverlappedWrite,
                                     &dwNumberOfBytesWritten, true) )
            {
               dwLastError = GetLastError();
               // ṩ߹رն˿ʱĴ
               if (dwLastError == ERROR_INVALID_HANDLE)  return false;
               // ⴦ֱ˳.
               PostHangupCall();
               return false;
            }            
            break;
         case WAIT_FAILED: // ȴʱڲΪֵԲܳ.
            PostHangupCall();
            return false;
         default: // Բܳ.
            PostHangupCall();
            return false;
         }
      }
      //{дʧܵ}
      // ¼дʣµֽ.
      dwNumberOfBytesToWrite -= dwNumberOfBytesWritten; //
      dwWhereToStartWriting+=dwNumberOfBytesWritten ;//
   } while (dwNumberOfBytesToWrite > 0);  // ֱдΪֹ!
   // дϺ󷵻.
   return true;
}//{TWriteThread.HandleWriteData}

void TWriteThread::PostHangupCall()
//д̹߳ʱ߳¼û
{            //մ        дʱ¼ʶ
   int i=0;
   PostMessage(m_handlemsg,USER_ONCOMMHANGUP, 0, LPARAM(i));
}
